---
title: Guide to the Fullscreen API
slug: Web/API/Fullscreen_API/Guide
tags:
  - API
  - Drawing
  - Full
  - Fullscreen API
  - Games
  - Graphics
  - Guide
  - display
  - full screen
  - fullscreen
  - screen
---
<div>{{DefaultAPISidebar("Fullscreen API")}}</div>

<p><span class="seoSummary">This article demonstrates how to use the <a href="/en-US/docs/Web/API/Fullscreen_API">Fullscreen API</a> to place a given element into full-screen mode, as well as how to detect when the browser enters or exits full-screen mode.</span></p>

<h2 id="Activating_full-screen_mode">Activating full-screen mode</h2>

<p>Given an element that you'd like to present in full-screen mode (such as a {{HTMLElement("video")}}, for example), you can present it in full-screen mode by calling its {{DOMxRef("Element.requestFullscreen", "requestFullscreen()")}} method.</p>

<p>Let's consider this {{HTMLElement("video")}} element:</p>

<pre class="brush: html notranslate">&lt;video controls id="myvideo"&gt;
  &lt;source src="somevideo.webm"&gt;&lt;/source&gt;
  &lt;source src="somevideo.mp4"&gt;&lt;/source&gt;
&lt;/video&gt;
</pre>

<p>We can put that video into full-screen mode as follows:</p>

<pre class="brush: js notranslate">var elem = document.getElementById("myvideo");
if (elem.requestFullscreen) {
  elem.requestFullscreen();
}</pre>

<p>This code checks for the existence of the <code>requestFullscreen()</code> method before calling it.</p>

<h3 id="Presentation_differences">Presentation differences</h3>

<p>It's worth noting a key difference here between the Gecko and WebKit implementations at this time: Gecko automatically adds CSS rules to the element to stretch it to fill the screen: "<code>width: 100%; height: 100%</code>". WebKit doesn't do this; instead, it centers the fullscreen element at the same size in a screen that's otherwise black. To get the same fullscreen behavior in WebKit, you need to add your own "<code>width: 100%; height: 100%;</code>" CSS rules to the element yourself:</p>

<pre class="brush: css notranslate">#myvideo:-webkit-full-screen {
  width: 100%;
  height: 100%;
}
</pre>

<p>On the other hand, if you're trying to emulate WebKit's behavior on Gecko, you need to place the element you want to present inside another element, which you'll make fullscreen instead, and use CSS rules to adjust the inner element to match the appearance you want.</p>

<h3 id="Notification">Notification</h3>

<p>When fullscreen mode is successfully engaged, the document which contains the element receives a {{Event("fullscreenchange")}} event. When fullscreen mode is exited, the document again receives a  {{Event("fullscreenchange")}} event. Note that the {{Event("fullscreenchange")}} event doesn't provide any information itself as to whether the document is entering or exiting fullscreen mode, but if the document has a non null {{DOMxRef("document.fullscreenElement", "fullscreenElement")}}, you know you're in fullscreen mode.</p>

<h3 id="When_a_fullscreen_request_fails">When a fullscreen request fails</h3>

<p>It's not guaranteed that you'll be able to switch into fullscreen mode. For example, {{HTMLElement("iframe")}} elements have the {{HTMLAttrXRef("allowfullscreen", "iframe")}} attribute in order to opt-in to allowing their content to be displayed in fullscreen mode. In addition, certain kinds of content, such as windowed plug-ins, cannot be presented in fullscreen mode. Attempting to put an element which can't be displayed in fullscreen mode (or the parent or descendant of such an element) won't work. Instead, the element which requested fullscreen will receive a <code>mozfullscreenerror</code> event. When a fullscreen request fails, Firefox will log an error message to the Web Console explaining why the request failed. In Chrome and newer versions of Opera however, no such warning is generated.</p>

<div class="notecard note">
<p><strong>Note:</strong> Fullscreen requests need to be called from within an event handler or otherwise they will be denied. </p>
</div>

<h2 id="Getting_out_of_full_screen_mode">Getting out of full screen mode</h2>

<p>The user always has the ability to exit fullscreen mode of their own accord; see {{Anch("Things your users want to know")}}. You can also do so programmatically by calling the {{DOMxRef("Document.exitFullscreen()")}} method.</p>

<h2 id="Other_information">Other information</h2>

<p>The {{DOMxRef("Document")}} provides some additional information that can be useful when developing fullscreen web applications:</p>

<dl>
 <dt>{{DOMxRef("DocumentOrShadowRoot.fullscreenElement")}}</dt>
 <dd>The <code>fullscreenElement</code> property tells you the {{DOMxRef("Element")}} that's currently being displayed fullscreen. If this is non-null, the document is in fullscreen mode. If this is null, the document is not in fullscreen mode.</dd>
 <dt>{{DOMxRef("Document.fullscreenEnabled")}}</dt>
 <dd>The <code>fullscreenEnabled</code> property tells you whether or not the document is currently in a state that would allow fullscreen mode to be requested.</dd>
</dl>

<h2 id="Things_your_users_want_to_know">Things your users want to know</h2>

<p>You'll want to be sure to let your users know that they can press the <kbd>Esc</kbd> key (or <kbd>F11</kbd>) to exit fullscreen mode.</p>

<p>In addition, navigating to another page, changing tabs, or switching to another application (using, for example, <kbd>Alt</kbd>-<kbd>Tab</kbd>) while in fullscreen mode exits fullscreen mode as well.</p>

<h2 id="Example">Example</h2>

<p>In this example, a video is presented in a web page. Pressing the <kbd>Return</kbd> or <kbd>Enter</kbd> key lets the user toggle between windowed and fullscreen presentation of the video.</p>

<p><a href="/samples/domref/fullscreen.html">View Live Examples</a></p>

<h3 id="Watching_for_the_Enter_key">Watching for the Enter key</h3>

<p>When the page is loaded, this code is run to set up an event listener to watch for the <kbd>Enter</kbd> key.</p>

<pre class="brush: js notranslate">document.addEventListener("keydown", function(e) {
  if (e.keyCode == 13) {
    toggleFullScreen();
  }
}, false);
</pre>

<h3 id="Toggling_fullscreen_mode">Toggling fullscreen mode</h3>

<p>This code is called when the user hits the <kbd>Enter</kbd> key, as seen above.</p>

<pre class="brush: js notranslate">function toggleFullScreen() {
  if (!document.fullscreenElement) {
    document.documentElement.requestFullscreen();
  } else {
    if (document.exitFullscreen) {
      document.exitFullscreen();
    }
  }
}</pre>

<p>This starts by looking at the value of the <code>fullscreenElement</code> attribute on the {{DOMxRef("document")}} (checking it prefixed with both <code>moz</code>, <code>ms</code>, or <code>webkit</code>). If it's <code>null</code>, the document is currently in windowed mode, so we need to switch to fullscreen mode. Switching to fullscreen mode is done by calling {{DOMxRef("element.requestFullscreen()")}}.</p>

<p>If fullscreen mode is already active (<code>fullscreenElement</code> is non-<code>null</code>), we call {{DOMxRef("document.exitFullscreen()")}}.</p>

<h2 id="Prefixing">Prefixing</h2>

<div class="blockIndicator geckoVersionNote">
<p><strong>Note:</strong> Currently, only Firefox 64 and Chrome 71 supports this unprefixed.</p>
</div>

<p>For the moment not all browsers are implementing the unprefixed version of the API (for vendor agnostic access to the Fullscreen API you can use <a href="https://github.com/rafrex/fscreen">Fscreen</a>). Here is the table summarizing the prefixes and name differences between them:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="row">Standard</th>
   <th scope="col">WebKit (Safari) / Blink (Chrome &amp; Opera) / Edge</th>
   <th scope="col">Gecko (Firefox)</th>
   <th scope="col">Internet Explorer</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th scope="row">{{DOMxRef("Document.fullscreen")}} {{Deprecated_Inline}}</th>
   <td><code>webkitIsFullScreen</code></td>
   <td><code>mozFullScreen</code></td>
   <td>-</td>
  </tr>
  <tr>
   <th scope="row">{{DOMxRef("Document.fullscreenEnabled")}}</th>
   <td><code>webkitFullscreenEnabled</code></td>
   <td><code>mozFullScreenEnabled</code></td>
   <td><code>msFullscreenEnabled</code></td>
  </tr>
  <tr>
   <th scope="row">{{DOMxRef("DocumentOrShadowRoot.fullscreenElement")}}</th>
   <td><code>webkitFullscreenElement</code></td>
   <td><code>mozFullScreenElement</code></td>
   <td><code>msFullscreenElement</code></td>
  </tr>
  <tr>
   <th scope="row">{{DOMxRef("Document.onfullscreenchange")}}</th>
   <td><code>onwebkitfullscreenchange</code></td>
   <td><code>onmozfullscreenchange</code></td>
   <td><code>onmsfullscreenchange</code></td>
  </tr>
  <tr>
   <th scope="row">{{DOMxRef("Document.onfullscreenerror")}}</th>
   <td><code>onwebkitfullscreenerror</code></td>
   <td><code>onmozfullscreenerror</code></td>
   <td><code>onmsfullscreenerror</code></td>
  </tr>
  <tr>
   <th scope="row">{{DOMxRef("Document.exitFullscreen()")}}</th>
   <td><code>webkitExitFullscreen()</code></td>
   <td><code>mozCancelFullScreen()</code></td>
   <td><code>msExitFullscreen()</code></td>
  </tr>
  <tr>
   <th scope="row">{{DOMxRef("Element.requestFullscreen()")}}</th>
   <td><code>webkitRequestFullscreen()</code></td>
   <td><code>mozRequestFullScreen()</code></td>
   <td><code>msRequestFullscreen()</code></td>
  </tr>
 </tbody>
</table>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Fullscreen")}}</td>
   <td>{{Spec2("Fullscreen")}}</td>
   <td>Initial version.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="Document.fullscreen"><code>Document.fullscreen</code></h3>

<p>{{Compat("api.Document.fullscreen")}}</p>

<h3 id="Document.fullscreenEnabled"><code>Document.fullscreenEnabled</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.Document.fullscreenEnabled")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Fullscreen_API">Using fullscreen mode</a></li>
 <li>{{DOMxRef("Element.requestFullscreen()")}}</li>
 <li>{{DOMxRef("Document.exitFullscreen()")}}</li>
 <li>{{DOMxRef("Document.fullscreen")}}</li>
 <li>{{DOMxRef("Document.fullscreenElement")}}</li>
 <li>{{CSSxRef(":fullscreen")}}, {{CSSxRef("::backdrop")}}</li>
 <li>{{HTMLAttrXRef("allowfullscreen", "iframe")}}</li>
</ul>
